<?php
/**********
Page de Téléchargements : download.php
Les scripts sont issus de ce site, dont je remercie l'auteur : https://sdz.tdct.org/sdz/compteur-de-telechargements.html
et "pages accordéon" issus de https://tympanus.net/codrops/2012/02/21/accordion-with-css3/ par Mary-Lou
Adaptations et Intégration dans adHoc Jean-Denis https://adhoc.71site.fr (1ère version janvier 2021) janvier 2024
Il est nécessaire d'avoir créé, dans l'admin, chacun des items de téléchargement,...
...dans une ou plusieurs catégories dédiées, dans une ou plusieurs "boîtes menu" privées ou publiques
***********/

// Construction de la page
require_once("include/config.inc");

// Variables à ne modifier que si c'est vraiment nécessaire...
$folder_stat = 'data/download/' ; // C'EST LE PLUS PRATIQUE : répertoire dans lequel seront stockées les statistiques 
										// !! ATTENTION : si modifié, doit être strictement identique plus bas dans la fonction NumberOfHit
$folder_archive = 'files/' ; // C'EST LE PLUS PRATIQUE : répertoire des téléchargements

// Variables à régler

$numcategorie = array('12', '13', '14', '15', '16', '17');
	// liste des numéros (Id) des catégories dans l'ordre où vous souhaitez qu'elles s'affichent
$nomcategoriecourt = array('adhoc', 'skins', 'camera-ug', 'survol', 'audio', 'carousel');
	// noms courts -un mot- des catégories dans le même ordre (permet de passer une variable dans l'URL de download.php pour ouvrir un soufflet)
$categorieouverte = '';
	// '' pour tout fermer par défaut ou éventuellement une de vos catégories à ouvrir par défaut
	// ( par exemple 'adhoc' ou 'skins' etc... )

$affdate = 'oui'; // affichage date : 'oui' ou 'non'
$SouC = 'S'; // si affichage date // 'S' : simple (sans heure) // 'C' : complète (date et heure)
$coum = 4; // date création : 3 ou date dernière modification : 4

$connex = 0; // 0 : une partie au moins est accessible au visiteur // ou 1 : tout le service n'est accessible qu'après connexion
			 //(ATTENTION : Dans ce dernier cas -privé- n'oubliez pas de faire de même pour la boîte menu qui contient vos catégories)

$typeaccordeon = 'checkbox' ; // 'radio' ou 'checkbox' suivant le type d'accordéon souhaité

	// dont définition des variables de langue
	if (USER_LANG == 'fr') { // fr
	$meta['title'] = 'Service de téléchargement'; // titre
	$meta['description'] = 'Téléchargements d\'archives'; // description
	$topmess = 'Téléchargements' ; // nom de la page
	$telecharge = 'Téléchargé ' ;
	$fois = ' fois' ;
	$message[3] = 'Création le : ';
	$message[4] = 'Dernière version le : ';
	$prive = 'Désolé, cette page est en accès privé.'; // avertissement si privé
	}
	elseif (USER_LANG == 'it') { // it
	$meta['title'] = 'Servizio di download'; // titre
	$meta['description'] = 'Download di archivi'; // description
	$topmess = 'Download' ; // nom de la page
	$telecharge = 'Telescritto ' ;
	$fois = ' volte' ;
	$message[3] = 'Creato il : ';
	$message[4] = 'Ultima versione il : ';
	$prive = 'Spiacenti, questa pagina è riservata.'; // avertissement si privé
	}
	elseif (USER_LANG == 'en') { // en
	$meta['title'] = 'Download service'; // titre
	$meta['description'] = 'Archive downloads'; // description
	$topmess = 'Download' ; // nom de la page
	$telecharge = 'Downloaded ' ;
	$fois = ' times' ;
	$message[3] = 'Created on : ';
	$message[4] = 'Last version on : ';
	$prive = 'Sorry, this page is private.'; // avertissement si privé
	}

// identification langue : ne pas modifier
$idlg = USER_LANG;

// Vérification du statut de connexion !!Attention ne fonctionnera qu'avec le CMS adHoc!!
if (empty($_COOKIE['adHocUser'])) { // pas de connexion donc ne voit que ce qui est public
	$statconnex = 0 ;
	}
else { // connexion donc voit aussi l'affichage privé
	$statconnex = 1 ;
	}

if ( isset( $_GET['cat'] ) ) // test existence du paramètre 'cat' passé dans l'URL
{ $categorie = $_GET['cat']; } // si oui récupération du paramètre 'cat'
else
{ $categorie = $categorieouverte; } // si non catégorie ouverte par défaut de votre réglage


if ( isset( $_GET['file'] ) ) // si le visiteur veut télécharger un fichier
{
	$name = htmlentities($_GET['file'], ENT_QUOTES); // sécurisation de la variable

	if ( file_exists($folder_stat.$name.'.txt')) // si le fichier existe
	{
		$FileContent = fopen($folder_stat.$name.'.txt', 'r+' ); // ouverture du fichier statistique contenant le nombre de hits
		$hit = fgets( $FileContent ); // récupération de la valeur
		$hit = intval( $hit ); // on vérifie qu’il s’agisse bien d’un nombre
		$hit++; // ajout de 1 au nombre de hits
		fseek( $FileContent, 0 ); // réinitialisation du curseur
		fputs( $FileContent, $hit ); // écriture dans le fichier
		fclose( $FileContent ); // fermeture du fichier
		header( "Location: $folder_archive$name.zip" ); // redirection vers le téléchargement .zip
	}
}

// Fonctions
function NumberOfHit( $name ) // création de la fonction NumberOfHit
{
	$folder_stat = 'data/download/' ; // C'EST LE PLUS PRATIQUE : répertoire dans lequel seront stockées les statistiques
											// !! ATTENTION : si modifié, doit être strictement identique plus haut 
	$file = $folder_stat . $name . '.txt' ; // nom du fichier de statistiques contenant le nombre de hits

	if ( file_exists( $file ) ) // si le fichier existe
	{
		$FileContent = fopen( $file , 'r' ); // ouverture du fichier
		$hit = fgets( $FileContent ); // récupération de la valeur
		fclose( $FileContent ); // fermeture du fichier
		return $hit; // retour de la valeur de $hit
	}
	else // si le fichier n’existe pas
	{
		touch( $file ); // création du fichier
		$FileContent = fopen( $file  , 'r+' ); // ouverture du fichier
		fseek( $FileContent, 0 ); // réinitialisation du curseur
		fputs( $FileContent, 0 ); // écriture dans le fichier
		fclose( $FileContent ); // fermeture du fichier
	}
}

function statutboite($num) // fonction statutboite pour vérifier les droits d'affichage de cette boite
{
$nblignes = count(file('modules/pages/mod_lat_pages_'.$num.'.inc')); // nombre de lignes du fichier
$contenuboite = fopen( 'modules/pages/mod_lat_pages_'.$num.'.inc', 'r' ); // ouverture fichier et contenu
	for ($i=0; $i < $nblignes ; $i++) {
		$lignenouvelle = fgets($contenuboite);
		if (strncmp($lignenouvelle, '$pm_rights = ', 13) === 0) // vérification ligne droit
		{$droitboite = substr($lignenouvelle, 13, 1);} // récupération valeur droit
	}
fclose($contenuboite); // fermeture fichier
return $droitboite;
}

function affichagedateS($date) { // date simple
$pourdate = substr($date, 6, 2)."/".substr($date, 4, 2)."/".substr($date, 0, 4);
return $pourdate;
}

function affichagedateC($date) { // date complète (avec heure)
$pourdate = substr($date, 6, 2)."/".substr($date, 4, 2)."/".substr($date, 0, 4)." ".substr($date, 8, 2)."h".substr($date, 10, 2);
return $pourdate;
}

function nettoyagenom($nom) { // nettoyage éventuel du nom de catégorie ou de page
if ($nom[0] == '"' && substr($nom, -1) == '"') //test présence de guillemets au début ET à la fin
{$nom = substr($nom, 1, -1);} // ... les supprime le cas échéant
return $nom;
}

// Construction de la page
include_once(PATH_INC."hpage.inc");
echo '
<!-- Début affichage "Service de Téléchargements" -->
';
htable($topmess, "100%");

// Affichage
if ($statconnex >= $connex) // vérification du statut avant affichage
{ // affichage en partie publique ou visiteur connecté

// Style
echo '
<style type="text/css">
.ac-container { /*attributs du conteneur*/
	width: 99%; /*largeur du conteneur*/
	margin: 10px auto 30px; /*marges extérieures H DG B*/
	text-align: left; /*alignement texte gauche*/
}
.ac-container label,
.ac-container input[type="checkbox"] + label { /*attributs des titres*/
	font-family: Open sans, sans-serif; /*police*/
	font-size: 19px; /*taille police*/
	margin:0 auto 5px; /*marges extérieures H DG B à adapter*/
	line-height: 28px; /*hauteur ligne*/
	padding: 5px 20px; /*marges intérieures*/
	position: relative;
	display: block;
	height: auto; /*hauteur*/
	min-height: 45px;
	cursor: pointer;
	color: #ffffff; /*couleur texte*/
	background: linear-gradient(to right, rgba( 0, 0, 0, 1), rgba( 75, 75, 75, 1)); /*couleur fond*/
	box-shadow:
		0px 0px 0px 1px rgba(155,155,155,0.3),
		0px 2px 2px rgba(0,0,0,0.1); /*ombre portée boite titre*/
}
.ac-container label:hover,
.ac-container input[type="checkbox"] + label:hover
{
	background: rgba( 75, 75, 75, 1); /*couleur fond au survol*/
}
.ac-container input:checked + label,
.ac-container input:checked + label:hover { /*attributs des titres sélectionnés et au survol*/
	background: rgba( 0, 0, 0, 1); /*couleur fond*/
	color: #D6AF84; /*couleur texte*/
	font-weight:bold; /*gras du texte*/
	box-shadow:
		0px 0px 0px 1px rgba(155,155,155,0.3),
		0px 2px 2px rgba(0,0,0,0.3); /*ombre portée boite titre*/
}
.ac-container label:before { /*pseudo-élément pour titre*/
	/*font-family:"fontawesome"; /*police de caractère*/
	/*content: "\f101"; /*caractère*/
	content: "►"; /*caractère*/
	padding-right:10px; /*marge intérieure droite*/
}
.ac-container input[type="checkbox"]:checked + label:before { /*pseudo-élément pour titre checkbox sélectionné*/
	/*font-family:"fontawesome"; /*police de caractère*/
	/*content: "\f103"; /*caractère*/
	content: "▼"; /*caractère*/
	padding-right:10px; /*marge intérieure droite*/
}
.ac-container input[type="radio"]:checked + label:before { /*pseudo-élément pour titre radio sélectionné*/
	/*font-family:"fontawesome"; /*police de caractère*/
	/*content: "\f107"; /*caractère*/
	content: ">>"; /*caractères*/
	padding-right:15px; /*marge intérieure droite*/
}
.ac-container input {
	display: none;
}
.ac-container article { /*attributs des articles masqués*/
	background: rgba(240,240,240,1); /*couleur fond*/
	margin-top: -5px; /*marge extérieure haute*/
	height: 0px; /*hauteur = 0 -> invisible*/
	transform:scale3d(1,0,1); /*échelle = 0 -> invisible*/
	transform-origin:0 0; /*origine transformation : ici haut*/
	overflow: hidden;
	position: relative;
}
.ac-container article p { /*attributs des paragraphes*/
	font-style: normal; /*à ajuster ou supprimer*/
	color: #000; /*couleur texte*/
	font-size: 14px; /*taille police*/
	line-height: 23px; /*hauteur ligne*/
	margin:0; /*marges extérieures*/
	padding: 0px 20px 5px 20px; /*marges intérieures*/
}
.ac-container input:checked ~ article { /*attributs des articles à la sélection*/
	transition:all 0.5s ease; /*transition à la sélection -temps, nature-*/
}
.ac-container input:checked ~ article.ac { /*attributs des articles à la sélection*/
	height: auto; /*hauteur*/
	transform:scale3d(1,1,1); /*échelle = 1 -> visible*/
}
.ac-container article h4 { /*titre h4*/
	margin-left:15px; /*marge extérieure gauche*/
	margin-top:-20px; /*marge extérieure haute*/
	font-size: 17px; /*taille police*/
	padding-bottom: 2px; /*marge intérieure basse*/
	color: #3366FF; /*couleur texte*/
}
.ac-container article h4 a { /*lien*/
	color:#D54500; /*couleur texte*/
}
.ac-container article h4 a:hover { /*lien au survol*/
	color:#6A2300; /*couleur texte*/
}
.ac-container article h4 a::after { /*pseudo-élément icone "caractère" du téléchargement*/ 
	/*font-family:"fontawesome"; /*police de caractère*/
	/*content:"\f1c6"; /*caractère ou "\f15c" ou...*/
	content:"⌂"; /*caractère*/
	font-size:40px; /*taille police*/
	padding-right:5px; /*marge intérieure droite*/
}
.sep { /*ligne de séparation*/
	border-top: 1px dashed rgba(0,0,0, 0.5); /*bordure haute*/
	border-bottom: 1px dashed rgba(255, 255, 255, 0.3); /*bordure basse*/
	margin: 4px 1% !important; /*marges extérieures*/
	clear:both;
}
.comment { /*commentaire*/
	float:left; /*à gauche*/
	width:94%; /*largeur*/
	background:rgba(255,255,255,1);
	margin:5px 3% !important;
	border-radius:5px;
	border:1px dotted rgba(24,34,84, 0.6);
}
p.comment {color:#111 !important;padding-bottom:10px !important;}

.comment a {color:#D54500; /*couleur lien*/}
.comment a:hover {color:#6A2300; /*couleur lien au survol*/}
.comment::before { /*pseudo-élément icone "caractère" du commentaire*/
	/*font-family:"fontawesome"; /*police de caractère*/
	/*content:"\f0c6"; /*caractère ou "\f16c" ou ...*/
	content:"֍"; /*caractère*/
	color:#3366FF; /*couleur texte*/
	margin-left:5px; /*marge extérieure gauche*/
}
@media screen and (max-width: 520px), screen and (max-device-width: 520px) { /* inférieur à 520px de largeur (MOBILE) */
.ac-container article h4 { /*titre h4*/
	font-size: 18px; /*taille police*/
}
.ac-container article h4 a::after { /*pseudo-élément icone "caractère" du téléchargement*/ 
	font-size:36px; /*taille police*/
}
}
</style>
';

// Elaboration contenu de la liste de toutes les catégories
$comptenbcategories = count(file('data/pages/list_'.$idlg.'.dbt')); // nombre de catégories dans la liste
$contenucategories = fopen( 'data/pages/list_'.$idlg.'.dbt', 'r' ); // ouverture fichier et contenu de cette liste

for ($i=0; $i < $comptenbcategories ; $i++) {
	$lignenouvelle = fgets($contenucategories);
	$elem = explode(";", $lignenouvelle);
		for ($j=0; $j < 6;$j++) {
		$chaquecategorie [$i][$j] = $elem[$j]; // création variables [catégorie][élément]
		}
}
fclose($contenucategories); // fermeture fichier

echo '
<section class="ac-container"><!-- début ac-container -->'; // début container accordéon

for ($k=0; $k < count($numcategorie) ; $k++) { // boucle pour le nombre max de catégories à afficher
	for ($i=0; $i < $comptenbcategories ; $i++) { // boucle pour chaque catégorie
		if ( $numcategorie [$k] == $chaquecategorie [$i][0]) { // vérification si la catégorie fait partie de la liste à afficher
			if ($statconnex >= statutboite($chaquecategorie [$i][1])) { // vérification du statut de la boite contenant la catégorie
				if ( $categorie == $nomcategoriecourt [$k] ) // test catégorie pour checked
					{ $ouvert = 'checked="checked"'; } // si oui >> ouvert
				else
					{ $ouvert = ''; } // sinon >> vide donc fermé
				// zone affichage nom catégorie
				echo '
				<div><!-- bloc ac-'.$numcategorie[$k].' -->
				<input '.$ouvert.' id="ac-'.$numcategorie[$k].'" name="accordion" type="'.$typeaccordeon.'" />
				<label for="ac-'.$numcategorie[$k].'">'.nettoyagenom($chaquecategorie [$i][3]).'</label>
				<article class="ac"><!-- début contenu soufflet accordéon -->';

				// Elaboration contenu de la catégorie en cours
				$comptenbritems = count(file('data/pages/pgidx_'.$numcategorie[$k].$idlg.'.dbt')); // nombre d'items dans la catégorie
				$contenucatencours = fopen( 'data/pages/pgidx_'.$numcategorie[$k].$idlg.'.dbt', 'r' ); // ouverture fichier et contenu de cette catégorie

				for ($x=0; $x < $comptenbritems ; $x++) {
					$lignenouvelle = fgets($contenucatencours);
					$elem = explode(";", $lignenouvelle);
						for ($y=0; $y < 6;$y++) {
						$chaqueitem [$x][$y] = $elem[$y]; // création variables [item][élément] pour tous les items
						}
					}
				fclose($contenucatencours); // fermeture fichier

				for ($z=0; $z < $comptenbritems ; $z++) {
					if ($chaqueitem [$z][2] == 'i') {continue;} // test de la page concernée (saute l'hypothèse si page inactive)
					include ('data/pages/page_'.$chaqueitem [$z][0].$idlg.'.inc'); // inclusion fichier page concernée
					$name = nettoyagenom($chaqueitem [$z][1]) ; // nom du fichier (et de l’archive) // nettoyage normalement inutile
					$comment = $ftxt; // commentaire pour ce téléchargement : récupération variable contenu page
					$result = NumberOfHit( $name ) ; // récupération du nombre de hits pour le nom concerné

// zone affichage contenu item - page concernée : lien, nom, éventuellement date, commentaire 
					if ($affdate == 'oui') { // test date
						if ($SouC == 'S')
						{$ladate = affichagedateS($chaqueitem [$z][$coum]);} // date simple
						else
						{$ladate = affichagedateC($chaqueitem [$z][$coum]);} // date complète
					$presencedate = '<span style="float:right;padding-right:40px;font-size:70%;"><i>'.$message[$coum].$ladate.'</i></span>';}
					else { $presencedate = '';} // sans date

					echo '
					<h4><a href="?file='.$name.'"></a>'.$name.$presencedate.'</h4>
					<p>'.$telecharge.'<b>'.$result.'</b>'.$fois.'</p>
					<div class="comment">'.$comment.'</div>
					<div class="sep"></div><!-- ligne séparation -->';
				}
				
				echo '
				</article><!-- fin contenu soufflet accordéon -->
				</div><!-- fin bloc ac-'.$numcategorie[$k].' -->';
			} // fin test statut boite
		} // fin test catégorie
	} // fin boucle $i
} // fin boucle $k

echo '
</section><!-- fin ac-container -->'; // fin container accordéon

} else { // privé
	echo $prive;
	echo '<br>';
	echo '<hr><hr>';
	}

// Référencement SVP ne pas supprimer
echo '
<!-- "Service de Téléchargements" - Jean-Denis https://adhoc.71site.fr janvier 2024 - Licence: GNU-GPL V3 -->
';

// fin contenu
btable();
include_once(PATH_INC."bpage.inc");
die();
?>

